"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_to_regexp_1 = require("path-to-regexp");
var BaseRouter_1 = __importDefault(require("./BaseRouter"));
var http_1 = require("../errors/http");
var http_2 = require("../errors/http");
var AwsProxyRouter = /** @class */ (function (_super) {
    __extends(AwsProxyRouter, _super);
    function AwsProxyRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AwsProxyRouter.prototype.lookup = function (receivedMethod, receivedPath) {
        if (!this.map) {
            throw http_1.NotImplementedControllerError;
        }
        var entries = Object.entries(this.map);
        var pathAndController = entries.find(function (_a) {
            var keyPath = _a[0];
            var _b = keyPath.split(BaseRouter_1.default.separator), method = _b[0], path = _b[1];
            if (method.toLowerCase() !== receivedMethod.toLowerCase()) {
                return false;
            }
            var matcher = (0, path_to_regexp_1.pathToRegexp)(path);
            return matcher.test(receivedPath);
        });
        if (!pathAndController) {
            throw http_2.NotFoundError;
        }
        return pathAndController[1];
    };
    AwsProxyRouter.prototype.expose = function () {
        var _this = this;
        return function (event, context) {
            try {
                var path = event.path, httpMethod = event.httpMethod;
                var controller = _this.lookup(httpMethod, path);
                if (typeof controller === 'function') {
                    return controller(event, context);
                }
                throw http_2.NotFoundError;
            }
            catch (e) {
                return Promise.resolve(BaseRouter_1.default.errorToHttpError(e));
            }
        };
    };
    return AwsProxyRouter;
}(BaseRouter_1.default));
exports.default = AwsProxyRouter;
