import { RouterController, RouterMapType } from '../types/TRouter';
export type BaseRouterUseType<T> = RouterController<T>[] | RouterController<T>;
export default abstract class BaseRouter<T, K> {
    protected map: RouterMapType<T, K>;
    static separator: string;
    getMapKey(route: RouterController<T>, separator?: string): string;
    private updateConfig;
    private usePath;
    private useController;
    /**
     * Overloaded method.
     *
     * It could be called with one parameter a BaseRouterUseType or array of BaseRouterUseType. Path should be specified in the object.
     * It could be called with two parameters: path, and BaseRouterUseType;
     *
     * I keeps this just for backward compatibility.
     *
     * @param args All arguments.
     */
    use(...args: [string, BaseRouterUseType<T>] | [BaseRouterUseType<T> | any]): void;
    delete(awsPath: string): void;
    expose(): T;
    static errorToHttpError(e: any): {
        statusCode: any;
        body: any;
    };
}
